VERSION 5.00
Begin VB.Form frmmain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "PROcode 2"
   ClientHeight    =   5625
   ClientLeft      =   4065
   ClientTop       =   4245
   ClientWidth     =   7500
   Icon            =   "FRMMAIN.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   Picture         =   "FRMMAIN.frx":030A
   ScaleHeight     =   375
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   500
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtdata 
      Appearance      =   0  'Flat
      BackColor       =   &H00181B19&
      BorderStyle     =   0  'None
      ForeColor       =   &H0000FF00&
      Height          =   330
      Left            =   1725
      TabIndex        =   0
      Top             =   1440
      Width           =   4050
   End
   Begin VB.Image Close 
      Height          =   5595
      Left            =   0
      Top             =   45
      Width           =   615
   End
   Begin VB.Label ClearLabel 
      BackStyle       =   0  'Transparent
      Caption         =   "Clear Display"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   161
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00008080&
      Height          =   210
      Left            =   5565
      TabIndex        =   1
      Top             =   2940
      Width           =   1185
   End
   Begin VB.Image open2 
      Height          =   1770
      Left            =   5400
      Top             =   3285
      Width           =   1860
   End
   Begin VB.Image open1 
      Height          =   4170
      Left            =   6660
      Top             =   765
      Width           =   585
   End
   Begin VB.Image cmddo 
      Height          =   720
      Left            =   3060
      Top             =   3945
      Width           =   1380
   End
   Begin VB.Image cmdclear 
      Height          =   765
      Left            =   5805
      Top             =   2130
      Width           =   750
   End
   Begin VB.Image DecodeSelect 
      Height          =   285
      Left            =   1440
      Top             =   3345
      Width           =   2535
   End
   Begin VB.Image EncodeSelect 
      Height          =   285
      Left            =   1410
      Top             =   3075
      Width           =   2535
   End
   Begin VB.Menu mnumode 
      Caption         =   "&Mode"
      Begin VB.Menu mnunormal 
         Caption         =   "&Normal mode"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnutorm 
         Caption         =   "&Tormentor mode"
      End
   End
   Begin VB.Menu mnuhelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuinst 
         Caption         =   "I&nstructions"
      End
      Begin VB.Menu mnuabout 
         Caption         =   "A&bout..."
      End
   End
End
Attribute VB_Name = "frmmain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Type arr
    matrix(1 To 4) As Integer
End Type

Dim temp As String
Dim data() As arr
Dim encoded() As arr
Dim key(1 To 4) As Integer
Dim tempstr As String
Dim strencoded As String
Dim length As Integer
Dim i As Integer, j, k As Integer
Dim letter As String
Dim matrices As Integer
Dim rest, extraspaces, position As Byte
Dim msg As String
Dim mode As Boolean '-- True if we're on normal mode, false if we're on Tormentor mode!
Dim action As Boolean '-- True if we're encoding, false if we're decoding.
Public CaseOpen As Boolean

Dim SwDnClosed  'Switch Down (Decode) in Closed Mode
Dim SwUpClosed  'Switch Up   (Encode) in Closed Mode
Dim SwDnOpen    'Switch Down (Decode) in Open Mode
Dim SwUpOpen    'Switch Up   (Encode) in Open Mode
Dim TransOpen  'Transition in Near Open Position
Dim TransClose 'Transition in Near Closed Position


Private Sub Close_Click()
If CaseOpen = True Then
    CaseOpen = False
    Call CloseCase
    ClearLabel.Visible = True
End If
End Sub

Private Sub cmdclear_Click()
txtdata.Text = ""

End Sub

Private Sub cmddo_Click()
If action = True Then
    tempstr = txtdata.Text
    tempstr = Trim(tempstr)
    length = Len(tempstr)
    '-- Matrices are 2x2, fitting 4 numbers, so we need to divide chars in 4-letter clusters
    matrices = length / 4
    '-- Correcting the division results
    If matrices = 0 Then matrices = 1
    rest = length Mod 4
    If rest = 1 Then matrices = matrices + 1
    '-- Calculate and add the necessary extra spaces at the end of our string
    extraspaces = 4 - rest
    If extraspaces > 0 Then
        For i = 1 To extraspaces
            tempstr = tempstr & " "
        Next i
    End If
    If matrices * 4 < length Then matrices = matrices + 1
    ReDim data(1 To matrices)
    ReDim encoded(1 To matrices)
    '-- Input & convert the chars of the string to their ASCII numeric values
    For i = 1 To matrices
        '-- Position within the current 4-letter cluster, relative to the whole string though
        position = i * 4
        For j = position - 3 To position
            '-- Counter k to know where in the matrix we are
            If j = position - 3 Then
                k = 1
            Else
                k = k + 1
            End If
            letter = Mid(tempstr, j, 1)
            data(i).matrix(k) = Asc(letter)
        Next j
    Next i
    SetKey (True)
    '-- Now do the matrix multiplications, pure math!
    For i = 1 To matrices
        encoded(i).matrix(1) = data(i).matrix(1) * key(1) + data(i).matrix(2) * key(3)
        encoded(i).matrix(2) = data(i).matrix(1) * key(2) + data(i).matrix(2) * key(4)
        encoded(i).matrix(3) = data(i).matrix(3) * key(1) + data(i).matrix(4) * key(3)
        encoded(i).matrix(4) = data(i).matrix(3) * key(2) + data(i).matrix(4) * key(4)
    Next i
    strencoded = ""
    '-- Write the encoded numbers in one string to give away
    For i = 1 To matrices
        For j = 1 To 4
            strencoded = strencoded & " " & Trim(Str(encoded(i).matrix(j)))
        Next j
    Next i
    If mode = True Then
        '-- Write our encoded string of numbers in a file
        Open "encoded.dmn" For Output As #1
        Print #1, strencoded
        Close #1
        MsgBox "Your text has been encoded and saved in file " & App.Path & "\encoded.dmn !", vbInformation, "It worked!!!"
    ElseIf mode = False Then
        Call Tormentor(strencoded, action)
    End If
ElseIf action = False Then
    On Error GoTo ErrorHandle
    If mode = True Then
        Open "encoded.dmn" For Input As #1
        '-- Inputting all data in file, to see how many matrices we need
        Line Input #1, tempstr
    ElseIf mode = False Then
        tempstr = txtdata.Text
    End If
    tempstr = Trim(tempstr)
    tempstr = tempstr & " "
    matrices = Len(tempstr) / 16
    ReDim encoded(1 To matrices)
    ReDim data(1 To matrices)
    Close #1
    '-- Re-opening the file for the actual input of the encoded numbers
    Open "encoded.dmn" For Input As #1
    If mode = True Then
        For i = 1 To matrices
            For j = 1 To 4
                '-- Input 4 chars at a time, trim them, and convert them to an integer to put in our matrices
                encoded(i).matrix(j) = CInt(Trim(Input(4, #1)))
            Next j
        Next i
    ElseIf mode = False Then
        k = 1
        For i = 1 To matrices
            For j = 1 To 4
                '-- Input 4 chars at a time, trim them, and convert them to an integer to put in our matrices
                encoded(i).matrix(j) = CInt(Trim(Mid(txtdata.Text, k, 4)))
                k = k + 4
            Next j
        Next i
    End If
    Close #1
    '-- Setting the key-matrix to be the decoding one (the reverse of the encoding key-matrix)
    SetKey (False)
    '-- Doing the actual decoding job
    For i = 1 To matrices
        data(i).matrix(1) = encoded(i).matrix(1) * key(1) + encoded(i).matrix(2) * key(3)
        data(i).matrix(2) = encoded(i).matrix(1) * key(2) + encoded(i).matrix(2) * key(4)
        data(i).matrix(3) = encoded(i).matrix(3) * key(1) + encoded(i).matrix(4) * key(3)
        data(i).matrix(4) = encoded(i).matrix(3) * key(2) + encoded(i).matrix(4) * key(4)
    Next i
    tempstr = ""
    For i = 1 To matrices
        For j = 1 To 4
            '-- Now we transform the char codes to the actual letters of the phrase
            letter = Chr(data(i).matrix(j))
            tempstr = tempstr & letter
        Next j
    Next i
    tempstr = Trim(tempstr)
    If mode = True Then
        '-- Put it in a file, and then on a msgbox
        Open "decoded.txt" For Output As #1
        Print #1, tempstr
        Close #1
        MsgBox tempstr, vbInformation, "The phrase has been decoded!"
    ElseIf mode = False Then
        Call Tormentor(tempstr, action)
    End If
End If
Exit Sub
'-- Just in case user selects DECODE and a file doesn't exist
'-- or put a decoded string to decode, or whatever stupid thing a user can do!
ErrorHandle:
    If Err.Number = 53 Then
        msg = "Default file <encoded.dmn> not found!"
        msg = msg & vbCrLf & vbCrLf
        msg = msg & "Please bring the encoded data file to " & App.Path & " !"
        MsgBox msg, vbExclamation, "Oops! You did it again..."
        Exit Sub
    ElseIf Err.Number = 9 Or Err.Number = 13 Then
        msg = "THAT is already decoded, or is NOT valid encoded data!!"
        msg = msg & vbCrLf
        msg = msg & "Please type/paste the correct encoded data!"
        MsgBox msg, vbExclamation, "What?!"
        Exit Sub
    Else
        msg = "Hmm... I don't know what you did, but it caused"
        msg = msg & vbCrLf & "a damn error of some kind!"
        msg = msg & vbCrLf & vbCrLf
        msg = msg & "Now watch it, and don't do that again!!"
        MsgBox msg, vbExclamation, "What the heck did you do?!"
    End If
    
End Sub

Private Sub DecodeSelect_Click()
Rem cmddo.Caption = "Decode it!"  (remarked by Nuclear)
action = False

If CaseOpen = True Then frmmain.Picture = SwDnOpen Else frmmain.Picture = SwDnClosed

End Sub

Private Sub EncodeSelect_Click()
Rem cmddo.Caption = "Encode it!"   (remarked by Nuclear)
action = True

If CaseOpen = True Then frmmain.Picture = SwUpOpen Else frmmain.Picture = SwUpClosed
End Sub

Private Sub Form_Load()
Rem optencode.Value = True         (remarked by Nuclear)
Rem cmddo.Caption = "Encode!"      (remarked by Nuclear)
mnunormal.Checked = True
action = True
mode = True

'/////////// These Lines are added by Nuclear ////////////
Set SwDnClosed = LoadPicture(App.Path & "\cl_dn_1.res")
Set SwUpClosed = LoadPicture(App.Path & "\cl_up_1.res")
Set SwDnOpen = LoadPicture(App.Path & "\op_dn_1.res")
Set SwUpOpen = LoadPicture(App.Path & "\op_up_1.res")
Set TransOpen = LoadPicture(App.Path & "\trans_op.res")
Set TransClose = LoadPicture(App.Path & "\trans_cl.res")
'/////////////////////////////////////////////////////////


End Sub

Sub SetKey(enc As Boolean)
If enc = True Then
    key(1) = 2
    key(2) = 1
    key(3) = 5
    key(4) = 3
ElseIf enc = False Then
    key(1) = 3
    key(2) = -1
    key(3) = -5
    key(4) = 2
End If

End Sub

Private Sub Image1_Click()

End Sub

Private Sub mnuabout_Click()
'////// Old About Remarked By Nuclear //////
'msg = "PROcode, v1.03,"
'msg = msg & vbCrLf & "Special Tormentor version."
'msg = msg & vbCrLf & vbCrLf
'msg = msg & " Dinos Mavridis, 2000."
'MsgBox msg, vbInformation, "Dinosm Networks"
AboutFrm.Show

End Sub

Private Sub mnuinst_Click()
msg = "This is a simple program that encodes/decodes a one-line phrase."
msg = msg & vbCrLf & vbCrLf
msg = msg & "When you encode a phrase, an encoded data file is generated in the directory of the application"
msg = msg & vbCrLf & "(currently " & App.Path & " )."
msg = msg & vbCrLf & vbCrLf
msg = msg & "This file must exist in the same directory, for the decoding to take place."
msg = msg & vbCrLf & vbCrLf
msg = msg & "After the decoding, you get a file <decoded.txt>, that contains the decoded phrase!"
MsgBox msg, vbInformation, "Here's how it works..."

End Sub

Private Sub mnunormal_Click()
mode = True
mnunormal.Checked = True
mnutorm.Checked = False
Rem optdecode.Caption = "I want to DECODE the current <encoded.dmn> file."

End Sub

Private Sub mnutorm_Click()
mode = False
mnunormal.Checked = False
mnutorm.Checked = True
Rem optdecode.Caption = "I want to DECODE the encrypted phrase in the text-box above."

End Sub

Private Sub optdecode_Click()
Rem cmddo.Caption = "Decode it!"
action = False

End Sub

Private Sub optencode_Click()
Rem cmddo.Caption = "Encode it!"
action = True

End Sub

Private Sub Tormentor(ByVal tempstr As String, action As Boolean)
If action = True Then
    txtdata.Text = ""
    txtdata.Text = tempstr
    'msg = "Since you selected the special Tormentor mode, your encoded message"
ElseIf action = False Then
    txtdata.Text = ""
    txtdata.Text = tempstr
    'msg = "Since you selected the special Tormentor mode, your decoded message"
End If
'msg = msg & vbCrLf & "has been put in the text-box of the program's form!"
'msg = msg & vbCrLf & vbCrLf
'msg = msg & "You can now copy and paste it wherever you like!!"
'MsgBox msg, vbInformation, "There you go!"

End Sub

Private Sub open1_Click()
If CaseOpen = False Then
    CaseOpen = True
    ClearLabel.Visible = False
    Call OpenCase
End If
End Sub

Private Sub OpenCase() 'Function Added by Nuclear
txtdata.Visible = False
frmmain.Picture = TransClose
For opdelay = 0 To 150000
Next
frmmain.Picture = TransOpen
For opdelay = 0 To 150000
Next
If action = True Then frmmain.Picture = SwUpOpen Else frmmain.Picture = SwDnOpen
txtdata.Visible = True
End Sub

Private Sub CloseCase() 'Function Added by Nuclear
txtdata.Visible = False
frmmain.Picture = TransOpen
For opdelay = 0 To 150000
Next
frmmain.Picture = TransClose
For opdelay = 0 To 150000
Next
If action = True Then frmmain.Picture = SwUpClosed Else frmmain.Picture = SwDnClosed
txtdata.Visible = True
End Sub

Private Sub open2_Click()
If CaseOpen = False Then
    CaseOpen = True
    ClearLabel.Visible = False
    Call OpenCase
End If
End Sub
